
#property copyright " 2005-2010 BJF Trading Group"
#property link      "http://www.iticsoftware.com"
#property show_inputs

#define major   3
#define minor   3

//-----------------------------------------------------------------------------

extern string ___tmp1_____________ = " --- Main settings ---";
extern string   ChannelID = "F5AC-11DB-BBA8";
extern int      Timer.msec = 1000;
extern bool     CheckConnection = true;
extern bool     MapSymbols = false;
extern string   MapSymbolsFile = "MapSymbols.txt";


extern string ___tmp2_____________ = " --- Lot section ---";
extern string   _LotType_format1__ = "[MS: Master] [FX: fixed] [BP: balance pcnt]";
extern string   _LotType_format2__ = "[EP: equity pcnt] [FMP: free margin pcnt]";
extern string   _LotType_format3__ = "[MRT: martingale] [C: custom]";
extern string   LotType = "MS";

extern double   MS.LotRatio = 2.0;
extern double   FX.FixedLot = 0.1;
extern double   BP.BalancePcnt = 10.0;
extern double   BP.BalanceBasis = 1000.0;
extern double   EP.EquityPcnt = 15.0;
extern double   EP.EquityBasis = 1000.0;
extern double   FMP.FreeMarginPcnt = 20.0;
extern double   FMP.FreeMarginBasis = 1000.0;
extern double   MRT.LotRatio = 2.0;

extern double   MinLot = 0.1;
extern double   MaxLot = 5.0;
extern int      LotDigits = 1;


extern string ___tmp3_____________ = " --- Trade params ---";
extern int      AccDigits = 5;
extern bool     MarketExecution = false;
extern string   _CopyMode_format__ = "[A: absolute] [P: pips]";
extern string   StopLossCopyMode = "A";
extern string   TakeProfitCopyMode = "A";
extern bool     OverwriteStopLoss = false;
extern int      NewStopLoss = 200;
extern bool     OverwriteTakeProfit = false;
extern int      NewTakeProfit = 200;
extern bool     OverwriteComment = false;
extern string   NewComment = "";
extern int      RepeatN = 5;
extern int      Slippage = 3;


extern string ___tmp4_____________ = " --- Filters ---";
extern bool     CheckMinMaxPriceDiff = true;
extern int      MinPriceDiff.StopLossSide = 0;
extern int      MaxPriceDiff.StopLossSide = 1000;
extern int      MinPriceDiff.TakeProfitSide = 0;
extern int      MaxPriceDiff.TakeProfitSide = 1000;
extern bool     CopyClose = true;


extern string ___tmp5_____________ = " --- Logs ---";
extern bool     LogMasterTrades = false;
extern bool     LogMasterHistoryTrades = false;
extern bool     LogSymbolNotFound = true;
extern bool     LogOrderAlreadyCopied = true;
extern bool     LogMinMaxPriceDiff = true;


extern string ___tmp6_____________ = " --- Labels ---";
extern int      Timer.Corner = 1;
extern int      Timer.X = 20;
extern int      Timer.Y = 20;
extern string   Timer.FontName = "Arial Narrow";
extern int      Timer.FontSize = 24;
extern color    Timer.FontColor = Gold;

extern int      Error.Corner = 1;
extern int      Error.X = 20;
extern int      Error.Y = 60;
extern string   Error.FontName = "Arial Narrow";
extern int      Error.FontSize = 18;
extern color    Error.FontColor = Red;

extern int      Demo.Corner = 0;
extern int      Demo.X = 20;
extern int      Demo.Y = 30;
extern int      Demo.dY = 26;
extern string   Demo.FontName = "Arial Narrow";
extern int      Demo.FontSize = 20;
extern color    Demo.FontColor = Red;
extern color    Demo.BackColor = White;

extern int      About.Corner = 3;
extern int      About.X = 20;
extern int      About.Y = 15;
extern int      About.dY = 16;
extern string   About.FontName = "Verdana";
extern int      About.FontSize = 9;
extern color    About.FontColor = Silver;

//-----------------------------------------------------------------------------

#include <stdlib.mqh>
#include <stderror.mqh>

#import "user32.dll"
  int GetParent(int hWnd);
#import

#import "mtfx_v30ds.dll"
  int _find_window(string class);

  int _init(int hTerminal, int hChart);
  int _deinit(int hTerminal, int hChart);
  
  int _mtfx_marker_send(int hTerminal, int hChart);
  int _mtfx_get_crc();
  int _mtfx_images_get(int hTerminal);

  int _images_calc_crc();
  bool _images_split();
  bool _images_get_info(int& master_cnt[], int& slave_cnt[]);
  int _images_total();
  
  bool _image_select(int index);
  bool _image_get_info(string& channel_id[], string& login[]);
  int _orders_total(int mode);
  bool _order_select(int pos, int mode);
  
  bool _order_get(
    int& ticket[], 
    int& open_time[], 
    int& type[], 
    double& lots[], 
    string& symbol[], 
    double& open_price[], 
    double& sl[], 
    double& tp[], 
    int& close_time[], 
    double& close_price[],
    datetime& expiration[],
    int& magic[], 
    string& comment[]);

#import

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix;

int init_cnt = 0;
int LastCRC = 0;
int LastTickCount = 0;
int hTerminal = 0;
int hChart = 0;
int marker_ret_code;

string m_channel_id[1]; 
string m_login[1];

int m_ticket[1];
int m_open_time[1];
int m_type[1];
double m_lots[1];
string m_symbol[1];
double m_open_price[1];
double m_sl[1];
double m_tp[1];
int m_close_time[1];
double m_close_price[1];
datetime m_expiration[1];
int m_magic[1];
string m_comment[1];

string MapSymbolsArr[][2];

int my_slippage;

int Demo.Counter = 0;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init()
{
  prefix = WindowExpertName() + "_";
  
  clear();

  //-----
  
  m_symbol[0] = "";
  m_comment[0] = "";
  m_channel_id[0] = "";
  m_login[0] = "";

  //64 bytes
  for (int i=0; i < 8; i++)
    m_symbol[0] = m_symbol[0] + "12345678";
  
  //256 bytes
  for (i=0; i < 32; i++)
    m_comment[0] = m_comment[0] + "12345678";
    
  //256 bytes
  for (i=0; i < 32; i++)
    m_channel_id[0] = m_channel_id[0] + "12345678";

  //256 bytes
  for (i=0; i < 32; i++)
    m_login[0] = m_login[0] + "12345678";

  //-----
  
  ReadMapSymbolsFile();
//Print("MapSymbols: ", MapSymbols("ABC"));
      
  //-----
  
  //warnings off
  if (false)
  {
    //MapSymbols("");
    //CustomLot("", 0.1);
    //CustomMinMaxPriceDiff("");
  }
}

void deinit() 
{
  _deinit(hTerminal, hChart);
  
  clear();
  Comment("");
}

void ReadMapSymbolsFile()
{
  ArrayResize(MapSymbolsArr, 0);
  
  //-----
  
  int hFile = FileOpen(MapSymbolsFile, FILE_READ|FILE_CSV);
  if (hFile < 0) 
  {
    int code = GetLastError();
    Print("[", MapSymbolsFile, "] FileOpen failed: ", ErrorDescription(code), " (", code, ")");
    return;
  }
  
  string line;
  int size;
  string pair[];
  
  while (!FileIsEnding(hFile))
  {
    line = FileReadString(hFile);
    line = StringTrimLeft(line);
    line = StringTrimRight(line);
    
    if (line == "") continue;
    if (StringFind(line, "//") != -1) continue;
    
    split(pair, line, "=>");
    if (ArraySize(pair) < 2) continue;

    size = ArrayRange(MapSymbolsArr, 0);
    ArrayResize(MapSymbolsArr, size+1);
    MapSymbolsArr[size][0] = pair[0];
    MapSymbolsArr[size][1] = pair[1];
    
//Print(pair[0], " ~ ", pair[1]);
  }
    
  FileClose(hFile);
}

int fpc()
{
  if (AccDigits == 5) return (10);
  if (AccDigits == 6) return (100);
  return (1); 
}

void start() 
{
  while (!IsStopped())
  {
    string msg = TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
    Timer.TextOut(msg);
    
    Demo.TextOut();
    About.TextOut();
    WindowRedraw();
      
    int res = main();
    if (res > 0) break;

    Sleep(Timer.msec);
  }
}

int main()
{
  Error.TextOut("");
  
  //-----
  
  hTerminal = TerminalHandle();
  if (hTerminal == 0)
  {
    Print("Terminal handle is NULL !!!");
    return (0);
  }
  
  hChart = WindowHandle(Symbol(), 0);
  if (hChart == 0)
  {
    Print("Chart handle is NULL !!!");
    return (0);
  }
  
  if (init_cnt == 0)
  {
    _init(hTerminal, hChart);
    init_cnt++;
  }
    
  //-----

  int ret = _find_window(ChannelID);
  if (ret == 0) 
  {
    Error.TextOut("Cannot find MultiTrade-Fx window !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }
  
  if (CheckConnection && !IsConnected()) 
  {
    Error.TextOut("No connection !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }
  
  if (AccountNumber() <= 0)
  {
    Error.TextOut("Account not ready !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }
    
  if (OrdersHistoryTotal() <= 0)
  {
    Error.TextOut("History not loaded !!!");
    WindowRedraw();
    
    LastCRC = 0;
    return (0);
  }


  bool OnTimer = (MathAbs(GetTickCount() - LastTickCount) >= 10*1000);
  
  if (OnTimer)
  {
    marker_ret_code = _mtfx_marker_send(hTerminal, hChart);
    LastTickCount = GetTickCount();
  }

  if (marker_ret_code == 1)
  {
    //Error.TextOut("Second instance of the script is not allowed.");
    //WindowRedraw();

    Alert("Second instance of the script is not allowed.");
    return (1);
  }
  
  //-----

  int i, j;
  int ticket, digits;
  double point;
  string symbol, msg;
  
  my_slippage = Slippage*fpc();
    
    
  int m_crc = _mtfx_get_crc();
  if (LastCRC != m_crc || OnTimer)
  {
    _mtfx_images_get(hTerminal);
    _images_split();
    
    int master_cnt[1], slave_cnt[1];
    _images_get_info(master_cnt, slave_cnt);
    //Comment("\n master_cnt: ", master_cnt[0], ",  slave_cnt: ", slave_cnt[0]);

    int images = _images_total();
    //Comment(images);
    
    for (i=0; i < images; i++)
    {
      if (!_image_select(i)) continue;
      
      _image_get_info(m_channel_id, m_login);
      //Print("_image_get_info: ", m_channel_id[0], " ", m_login[0]);
      
      int orders = _orders_total(MODE_HISTORY);
      for (j=0; j < orders; j++)
      {
        if (!_order_select(j, MODE_HISTORY)) continue;
        
        _order_get(
          m_ticket,
          m_open_time,
          m_type,
          m_lots,
          m_symbol,
          m_open_price,
          m_sl,
          m_tp,
          m_close_time,
          m_close_price,
          m_expiration,
          m_magic,
          m_comment);
        
        if (LogMasterHistoryTrades)
        {
          msg = StringConcatenate(
            "Master history: ticket ", m_ticket[0],
            "; open_time: ", TimeToStr(m_open_time[0]),
            "; type: ", OrdT2Str(m_type[0]),
            "; lots: ", m_lots[0],
            "; symbol: ", m_symbol[0],
            "; open_price: ", m_open_price[0],
            "; sl: ", m_sl[0],
            "; tp: ", m_tp[0],
            "; close_time: ", TimeToStr(m_close_time[0]),
            "; close_price: ", m_close_price[0],
            "; expir.: ", m_expiration[0],
            "; magic: ", m_magic[0],
            "; comment: ", m_comment[0]);
          WriteLog(msg);
        }
                  
        symbol = MapSymbols(m_symbol[0]);
        digits = MarketInfo(symbol, MODE_DIGITS);
        point = MarketInfo(symbol, MODE_POINT)*fpc();
        
        if (point == 0)
        {
          if (LogSymbolNotFound)
          {
            msg = "[Main] Does \"" +symbol+ "\" symbol present in the MarketWatch window?";
            WriteLog(msg);
          }
          
          continue;
        }

        if (MathAbs(m_lots[0] - 1.0) >= 0.0001) continue;
        

        m_open_price[0] = NormalizeDouble(m_open_price[0], digits);
        m_close_price[0] = NormalizeDouble(m_close_price[0], digits);
        m_sl[0] = NormalizeDouble(m_sl[0], digits);
        m_tp[0] = NormalizeDouble(m_tp[0], digits);
       
        ticket = GetOrderByMagic(m_ticket[0], MODE_TRADES);
        if (ticket > 0) KillOrder();
      }
      
      //-----
      
      orders = _orders_total(MODE_TRADES);
      for (j=0; j < orders; j++)
      {
        if (!_order_select(j, MODE_TRADES)) continue;
        
        _order_get(
          m_ticket,
          m_open_time,
          m_type,
          m_lots,
          m_symbol,
          m_open_price,
          m_sl,
          m_tp,
          m_close_time,
          m_close_price,
          m_expiration,
          m_magic,
          m_comment);

        if (LogMasterTrades)
        {
          msg = StringConcatenate(
            "Master trades: ticket ", m_ticket[0],
            "; open_time: ", TimeToStr(m_open_time[0]),
            "; type: ", OrdT2Str(m_type[0]),
            "; lots: ", m_lots[0],
            "; symbol: ", m_symbol[0],
            "; open_price: ", m_open_price[0],
            "; sl: ", m_sl[0],
            "; tp: ", m_tp[0],
            "; close_time: ", TimeToStr(m_close_time[0]),
            "; close_price: ", m_close_price[0],
            "; expir.: ", m_expiration[0],
            "; magic: ", m_magic[0],
            "; comment: ", m_comment[0]);
          WriteLog(msg);
        }
        
        symbol = MapSymbols(m_symbol[0]);
        digits = MarketInfo(symbol, MODE_DIGITS);
        point = MarketInfo(symbol, MODE_POINT)*fpc();
        
        if (point == 0)
        {
          if (LogSymbolNotFound)
          {
            msg = "[Main] Does " +symbol+ " present in the MarketWatch window?";
            WriteLog(msg);
          }
          
          continue;
        }
        
        if (MathAbs(m_lots[0] - 1.0) >= 0.0001) continue;
                
        //partial close
        //if (StringFind(m_comment[0], "from #") != -1) continue;
          
        m_open_price[0] = NormalizeDouble(m_open_price[0], digits);
        m_close_price[0] = NormalizeDouble(m_close_price[0], digits);
        m_sl[0] = NormalizeDouble(m_sl[0], digits);
        m_tp[0] = NormalizeDouble(m_tp[0], digits);
        
        ticket = GetOrderByMagic(m_ticket[0], MODE_HISTORY);
        if (ticket > 0)
        {
          if (LogOrderAlreadyCopied)
          {
            WriteLog("[main] Ticket #" +m_ticket[0]+ " found in the history, no action");
          }
          
          continue;
        }
        
        ticket = GetOrderByMagic(m_ticket[0], MODE_TRADES);
          
        if (ticket == -1)
        {
          SetOrder();
        }
        else
        {
          if (m_open_price[0] != NormalizeDouble(OrderOpenPrice(), digits) || 
              m_sl[0] != NormalizeDouble(OrderStopLoss(), digits) ||
              m_tp[0] != NormalizeDouble(OrderTakeProfit(), digits))
          {
            ModifyOrder();
          }
        }
      }      
    }
    
    LastCRC = m_crc;
  }
  
//Comment(m_crc, "  ", _images_calc_crc());  

  return (0);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void WriteLog(string msg)
{ 
  Print("[M: " + m_login[0] + "] " + msg);
}

int GetOrderByMagic(int magic, int mode)
{
  int cnt = 0;  
  if (mode == MODE_TRADES) cnt = OrdersTotal();
  if (mode == MODE_HISTORY) cnt = OrdersHistoryTotal();
  
  for (int i=0; i<cnt; i++)
  {
    if (!OrderSelect(i, SELECT_BY_POS, mode)) continue;
    
    if (OrderMagicNumber() == magic) return (OrderTicket());
  }
  
  return (-1);
}

double GetLot()
{
  double lot = FX.FixedLot;
  string symbol = MapSymbols(m_symbol[0]);
  string mLT = ToUpper(LotType);
  mLT = StringTrim(mLT);

//--------------------------------------------------------
// [MS: Master]
//--------------------------------------------------------
  if (mLT == "MS")
  {
    lot = MS.LotRatio * m_lots[0];  
  }

//--------------------------------------------------------
// [FX: fixed]
//--------------------------------------------------------
  else if (mLT == "FX")
  {
    lot = FX.FixedLot;
  }

//--------------------------------------------------------
// [BP: balance pcnt]
//--------------------------------------------------------
  else if (mLT == "BP") 
  {
    lot = AccountBalance()/BP.BalanceBasis * BP.BalancePcnt/100.0;
  }

//--------------------------------------------------------
// [EP: equity pcnt]
//--------------------------------------------------------
  else if (mLT == "EP") 
  {
    lot = AccountEquity()/EP.EquityBasis * EP.EquityPcnt/100.0;
  }

//--------------------------------------------------------
// [FMP: free margin pcnt]
//--------------------------------------------------------
  else if (mLT == "FMP") 
  {
    lot = AccountFreeMargin()/FMP.FreeMarginBasis * FMP.FreeMarginPcnt/100.0;
  }

//--------------------------------------------------------
// [MRT: martingale]
//--------------------------------------------------------
  else if (mLT == "MRT")
  {
    lot = FX.FixedLot;
    
    if (LastOrderSelect(MODE_HISTORY, OP_BUY, OP_SELL))
    {
      if (OrderProfit() < 0)
      {
        lot = MRT.LotRatio*OrderLots();
      }
    }
  }

//--------------------------------------------------------
// [C: custom]
//--------------------------------------------------------
  else if (mLT == "C")
  {
    lot = CustomLot(symbol, m_lots[0]);
    return (lot);
  }
  
  //-----

  if (lot < MinLot) lot = MinLot;
  if (lot > MaxLot) lot = MaxLot;
  
  double max_lot = MarketInfo(symbol, MODE_MAXLOT);
  double min_lot = MarketInfo(symbol, MODE_MINLOT);
  if (lot < min_lot) lot = min_lot;
  if (lot > max_lot) lot = max_lot;

  lot = NormalizeDouble(lot, LotDigits);
  
  return (lot);
}

int SetOrder()
{
  int i, j, digits, ticket;
  double price, bid, ask, point, sl, tp;
  string msg, comment;
  bool res;
  
  string symbol = MapSymbols(m_symbol[0]);
  
  int min_price_diff.sl_side, min_price_diff.tp_side;
  int max_price_diff.sl_side, max_price_diff.tp_side;  
  CustomMinMaxPriceDiff(symbol, min_price_diff.sl_side, min_price_diff.tp_side, max_price_diff.sl_side, max_price_diff.tp_side);

  
  int type = m_type[0];
  
  point = MarketInfo(symbol, MODE_POINT)*fpc();
  
  digits = MarketInfo(symbol, MODE_DIGITS);

  sl = m_sl[0];
  tp = m_tp[0];
  comment = m_comment[0];
 
  //-----
  
  bool price_diff.sl_side, price_diff.tp_side;
  double price_diff;
    
  if (type == OP_BUY) 
  {
    for (i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);
      
      if (CheckMinMaxPriceDiff && ask <= m_open_price[0])
      {
        price_diff = m_open_price[0] - ask;
        price_diff.sl_side = (min_price_diff.sl_side*point <= price_diff && price_diff <= max_price_diff.sl_side*point);
        
        if (!price_diff.sl_side)
        {
          if (LogMinMaxPriceDiff)
          {
            msg = StringConcatenate(
              "[SetOrder] PriceDiff filter for StopLoss side triggered: ",
              " master_ticket: ", m_ticket[0],
              "; symbol: ", symbol,
              "; type: ", "BUY",
              "; master_open_price: ", DoubleToStr(m_open_price[0], digits),
              "; slave_open_price: ", DoubleToStr(ask, digits),
              "; price_diff: ", DoubleToStr(price_diff/point, 0), " pips",
              "; min_price_diff.sl_side: ", min_price_diff.sl_side, " pips",
              "; max_price_diff.sl_side: ", max_price_diff.sl_side, " pips");
        
            WriteLog(msg);
          }
          
          return (false);
        }
      }

      if (CheckMinMaxPriceDiff && ask >= m_open_price[0])
      {
        price_diff = ask - m_open_price[0];
        price_diff.tp_side = (min_price_diff.tp_side*point <= price_diff && price_diff <= max_price_diff.tp_side*point);
        
        if (!price_diff.tp_side)
        {
          if (LogMinMaxPriceDiff)
          {
            msg = StringConcatenate(
              "[SetOrder] PriceDiff filter for TakeProfit side triggered: ",
              " master_ticket: ", m_ticket[0],
              "; symbol: ", symbol,
              "; type: ", "BUY",
              "; master_open_price: ", DoubleToStr(m_open_price[0], digits),
              "; slave_open_price: ", DoubleToStr(ask, digits),
              "; price_diff: ", DoubleToStr(price_diff/point, 0), " pips",
              "; min_price_diff.tp_side: ", min_price_diff.tp_side, " pips",
              "; max_price_diff.tp_side: ", max_price_diff.tp_side, " pips");
        
            WriteLog(msg);
          }
          
          return (false);
        }
      }
      
      //-----

      price = ask;

      if (StopLossCopyMode == "P" || StopLossCopyMode == "p")
      {
        if (sl > 0) sl = price - (m_open_price[0] - sl);
      }

      if (TakeProfitCopyMode == "P" || TakeProfitCopyMode == "p")
      {
        if (tp > 0) tp = price + (tp - m_open_price[0]);
      }
      
      //-----
      
      if (OverwriteStopLoss)
      {
        sl = If(NewStopLoss > 0, price - NewStopLoss*point, 0);
      }

      if (OverwriteTakeProfit)
      {
        tp = If(NewTakeProfit > 0, price + NewTakeProfit*point, 0);
      }
      
      if (OverwriteComment)
      {
        comment = NewComment;
      }
      
      //-----
  
      if (MarketExecution)
      {
        ticket = Buy(symbol, GetLot(), price, 0, 0, m_ticket[0], comment);
        
        if (ticket > 0 && (sl > 0 || tp > 0))
        {
          for (j=0; j < RepeatN; j++)
          {
            OrderSelect(ticket, SELECT_BY_TICKET);
            res = OrderModify(ticket, OrderOpenPrice(), sl, tp, 0);
            if (res) break;
          }
        }
      
        if (ticket > 0) break;
      }
      else
      {
        ticket = Buy(symbol, GetLot(), price, sl, tp, m_ticket[0], comment);
        if (ticket > 0) break;
      }
    }
    
    return (ticket > 0);
  }

  //-----

  if (type == OP_SELLSTOP)
  {
    price = m_open_price[0];

    if (OverwriteStopLoss)
    {
      sl = If(NewStopLoss > 0, price + NewStopLoss*point, 0);
    }

    if (OverwriteTakeProfit)
    {
      tp = If(NewTakeProfit > 0, price - NewTakeProfit*point, 0);
    }

    if (OverwriteComment)
    {
      comment = NewComment;
    }

    //-----
  
    for (i=0; i < RepeatN; i++)
    {
      ticket = SetSellStop(symbol, GetLot(), price, sl, tp, m_ticket[0], comment);
      if (ticket > 0) break;
    }
    
    return (ticket > 0);
  }
    
  return (false);
}

int ModifyOrder()
{
  double sl, tp;
  int type = m_type[0];

  string symbol = MapSymbols(m_symbol[0]);
  double point = MarketInfo(symbol, MODE_POINT)*fpc();
  
  
  sl = m_sl[0];
  tp = m_tp[0];

  //-----
    
  if (type == OP_BUY)
  {
    if (StopLossCopyMode == "P" || StopLossCopyMode == "p")
    {
      if (sl > 0) sl = OrderOpenPrice() - (m_open_price[0] - sl);
    }

    if (TakeProfitCopyMode == "P" || TakeProfitCopyMode == "p")
    {
      if (tp > 0) tp = OrderOpenPrice() + (tp - m_open_price[0]);
    }

    //-----

    if (OverwriteStopLoss)
    {
      sl = If(NewStopLoss > 0, OrderOpenPrice() - NewStopLoss*point, 0);
    }

    if (OverwriteTakeProfit)
    {
      tp = If(NewTakeProfit > 0, OrderOpenPrice() + NewTakeProfit*point, 0);
    }

    //-----
    
    for (int i=0; i < RepeatN; i++)
    {
      if (NormalizeDouble(OrderStopLoss(), Digits) == NormalizeDouble(sl, Digits) && 
          NormalizeDouble(OrderTakeProfit(), Digits) == NormalizeDouble(tp, Digits)) break;
      
      bool res = OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0);
      if (res) break;
    }
    
    return (res);
  }

  if (type == OP_SELLSTOP)
  {
    if (OverwriteStopLoss)
    {
      sl = If(NewStopLoss > 0, m_open_price[0] + NewStopLoss*point, 0);
    }

    if (OverwriteTakeProfit)
    {
      tp = If(NewTakeProfit > 0, m_open_price[0] - NewTakeProfit*point, 0);
    }

    //-----
    
    for (i=0; i < RepeatN; i++)
    {
      if (NormalizeDouble(OrderOpenPrice(), Digits) == NormalizeDouble(m_open_price[0], Digits) && 
          NormalizeDouble(OrderStopLoss(), Digits) == NormalizeDouble(sl, Digits) && 
          NormalizeDouble(OrderTakeProfit(), Digits) == NormalizeDouble(tp, Digits)) break;
    
      res = OrderModify(OrderTicket(), m_open_price[0], sl, tp, 0);
      if (res) break;
    }
    
    return (res);
  }    
  
  return (false);
}

int KillOrder()
{
  double bid, ask, lot;
  string msg;
  
  string symbol = MapSymbols(m_symbol[0]);
  int type = m_type[0];

  
  //-----
        
  if (type == OP_BUY) 
  {
    if (!CopyClose) return (-1);
    
    for (int i=0; i < RepeatN; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
      bid = MarketInfo(symbol, MODE_BID);

/*    
      lot = GetLot();
      if (lot > OrderLots()) lot = OrderLots();
      
      //partial close
      if ((StringFind(OrderComment(), "from #") != -1) || (StringFind(OrderComment(), "to #") != -1)) lot = OrderLots();
*/
      
      lot = OrderLots();
            
      bool res = CloseOrder(OrderTicket(), lot, bid);
      if (res) break;  
    }
    
    return (res);
  }

  //-----
  
  if (type == OP_SELLSTOP)
  {
    for (i=0; i < RepeatN; i++)
    {
      res = DeleteOrder(OrderTicket());
      if (res) break;
    }
    
    return (res);
  }

  return (false);
}

string OrdT2Str(int type) 
{
  switch (type)
  {
    case OP_BUY:        return ("Buy"); 
    case OP_SELL:       return ("Sell");
    case OP_BUYLIMIT:   return ("BuyLimit");
    case OP_SELLLIMIT:  return ("SellLimit");
    case OP_BUYSTOP:    return ("BuyStop");
    case OP_SELLSTOP:   return ("SellStop");
    default:            return (type);
  }
}

string ToUpper(string str)
{
  int len = StringLen(str);
  for (int j=0; j < len; j++) 
  {
    int ch = StringGetChar(str, j);
    if ('a' <= ch && ch <= 'z') 
    {
      ch += 'A' - 'a';
      str = StringSetChar(str, j, ch);
    }
  }
  
  return (str);
}

string StringTrim(string str)
{
  str = StringTrimLeft(str);
  str = StringTrimRight(str);
  
  return (str);
}

bool LastOrderSelect(int pool, int type1, int type2 = -1)
{
  datetime tm = -1;
  int ticket = -1;

  if (pool == MODE_TRADES)
  {
    int cnt = OrdersTotal();
    for (int i=0; i < cnt; i++) 
    {
      if (!OrderSelect(i, SELECT_BY_POS, pool)) continue;
      if (OrderSymbol() != Symbol()) continue;
        
      int type = OrderType();
      if (type == type1 || type == type2)
      {
        if (OrderOpenTime() > tm)
        {
          tm = OrderOpenTime();
          ticket = OrderTicket();
        }
      }
    }
  
    return (OrderSelect(ticket, SELECT_BY_TICKET));
  }

  if (pool == MODE_HISTORY)
  {
    cnt = OrdersHistoryTotal();
    for (i=0; i < cnt; i++) 
    {
      if (!OrderSelect(i, SELECT_BY_POS, pool)) continue;
      if (OrderSymbol() != Symbol()) continue;
        
      type = OrderType();
      if (type == type1 || type == type2)
      {
        if (OrderCloseTime() > tm)
        {
          tm = OrderCloseTime();
          ticket = OrderTicket();
        }
      }
    }
  
    return (OrderSelect(ticket, SELECT_BY_TICKET));
  }
    
  return (false);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 1000;
int SleepErr = 5000;

int Buy(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Buy \"", symbol, "\", ", _lot, ", ", _price, ", ", my_slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  int res = OrderSend(symbol, OP_BUY, lot, price, my_slippage, sl, tp, comment, magic, 0);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellStop(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellStop \"", symbol, "\", ", _lot, ", ", _price, ", ", my_slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLSTOP, lot, price, my_slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLSTOP order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price) 
{
  if (!OrderSelect(ticket, SELECT_BY_TICKET)) return(false);
  if (OrderCloseTime() > 0) return(false);
  
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", my_slippage);
  
  bool res = OrderClose(ticket, lot, price, my_slippage);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

bool DeleteOrder(int ticket) 
{
  Print("DeleteOrder ", ticket);
  
  bool res = OrderDelete(ticket);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("DeleteOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double If(bool cond, double if_true, double if_false)
{
  if (cond) return (if_true);
  return (if_false);
}

void split(string& arr[], string str, string sym) 
{
  ArrayResize(arr, 0);
  string item;
  int pos, size;
  
  int len = StringLen(str);
  for (int i=0; i < len;) 
  {
    pos = StringFind(str, sym, i);
    if (pos == -1) pos = len;
    
    if (pos-i == 0)
    {
      item = "";
    }
    else
    {
      item = StringSubstr(str, i, pos-i);
      item = StringTrimLeft(item);
      item = StringTrimRight(item);
    }
    
    size = ArraySize(arr);
    ArrayResize(arr, size+1);
    arr[size] = item;
    
    i = pos+StringLen(sym);
  }
  
  size = ArraySize(arr);
  if (size == 1)
  {
    ArrayResize(arr, size+1);
    arr[size] = "";
  }
}

int TerminalHandle()
{
  int hWnd = WindowHandle(Symbol(), Period());
  int hParent = 0;
  
  while (!IsStopped()) 
  {
    hWnd = GetParent(hWnd);
    if (hWnd == 0) break;
    hParent = hWnd;
  }
  
  return (hParent);
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
  
  WindowRedraw();
  Comment("");
}


void Timer.TextOut(string txt)
{
  string obj_name = prefix + "timer";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Timer.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Timer.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Timer.Corner);

  ObjectSetText(obj_name, txt, Timer.FontSize, Timer.FontName, Timer.FontColor);
}

void Error.TextOut(string txt)
{
  string obj_name = prefix + "err";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Error.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Error.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Error.Corner);

  ObjectSetText(obj_name, txt, Error.FontSize, Error.FontName, Error.FontColor);
}

void Demo.TextOut()
{
  string obj_name, txt;
  
  txt = CharToStr(108);

  for (int i=0; i < 430; i += 5)
  {
    for (int j=-15; j < 65; j += 5)
    {
      obj_name = prefix + "demo_bg_" + i + " _" + j;
      if (ObjectFind(obj_name) == -1) 
      {
        ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
      }

      ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X + i - 20);
      ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y + j);
      ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);
      ObjectSet(obj_name, OBJPROP_BACK, true);

      ObjectSetText(obj_name, txt, 30, "Wingdings", Demo.BackColor);
    }
  }

  //-----
    
  obj_name = prefix + "demo1";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  txt = "     DEMO version  ";
  for (i = 0; i < Demo.Counter; i++)
  {
    txt = txt + ".";
  }
  
  Demo.Counter += 1;
  if (Demo.Counter > 3) Demo.Counter = 0;
  
  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
  //-----

  txt = "1) Copied BUY and SELLSTOP orders only";
  
  obj_name = prefix + "demo2";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y+Demo.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
  //-----
  
  txt = "2) Copied orders with 1.0 lots volume only"; 
  
  obj_name = prefix + "demo3";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, Demo.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, Demo.Y+2*Demo.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, Demo.Corner);

  ObjectSetText(obj_name, txt, Demo.FontSize, Demo.FontName, Demo.FontColor);
  
}

void About.TextOut()
{
  string txt;
  string spr = "--------------------------------------";
  
  string obj_name = prefix + "about1";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "http://www.iticsoftware.com";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
  
  obj_name = prefix + "about2";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = " 2005-2009 BJF Trading Group";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);


  obj_name = prefix + "about2b";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+2*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = spr;
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, Red);

  //-----
  
  obj_name = prefix + "about3";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+3*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "Channel ID: " + ChannelID;
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
    
  obj_name = prefix + "about4";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+4*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "Type: CopyTool slave script";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);

  //-----
    
  obj_name = prefix + "about5";
  if (ObjectFind(obj_name) == -1) {
    ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0);
  }

  ObjectSet(obj_name, OBJPROP_XDISTANCE, About.X);
  ObjectSet(obj_name, OBJPROP_YDISTANCE, About.Y+5*About.dY);
  ObjectSet(obj_name, OBJPROP_CORNER, About.Corner);

  txt = "File: " + WindowExpertName() + ".ex4";
  ObjectSetText(obj_name, txt, About.FontSize, About.FontName, About.FontColor);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string MapSymbols(string sym)
{
  if (!MapSymbols) return (sym);
  
  int size = ArraySize(MapSymbolsArr);
  for (int i=0; i < size; i++)
  {
    if (sym == MapSymbolsArr[i][0])
    {
      return (MapSymbolsArr[i][1]);
    }
  }
  
  //-----
  
  string tmp[];
  string prefix, core, postfix;
  int pos1, pos2;

  for (i=0; i < size; i++)
  {
    if (StringFind(MapSymbolsArr[i][0], "[OTHER_SYMBOL]") != -1 && StringFind(MapSymbolsArr[i][1], "[OTHER_SYMBOL]") != -1)
    {
      split(tmp, MapSymbolsArr[i][0], "[");
      prefix = tmp[0];

      split(tmp, MapSymbolsArr[i][0], "]");
      postfix = tmp[1];
//Print("prefix: ", prefix, "; postfix: ", postfix);
      pos1 = 0;
      if (StringFind(sym, prefix, 0) != -1)
        pos1 = StringLen(prefix);

      pos2 = StringLen(sym);
      if (StringLen(sym) > StringLen(postfix) && StringFind(sym, postfix, StringLen(sym)-StringLen(postfix)) != -1)
        pos2 = StringLen(sym)-StringLen(postfix)-1;
        
      core = StringSubstr(sym, pos1, pos2-pos1+1);
//Print("pos1: ", pos1, "; pos2: ", pos2, "; core: ", core);
      //-----

      split(tmp, MapSymbolsArr[i][1], "[");
      prefix = tmp[0];

      split(tmp, MapSymbolsArr[i][1], "]");
      postfix = tmp[1];

//Print(MapSymbolsArr[i][1], "; prefix2: ", prefix, "; postfix2: ", postfix);
      
      return (prefix+core+postfix);
    }
  }
  
  //-----
 
  return (sym);
}


void CustomMinMaxPriceDiff(string sym, int& min_price_diff.sl_side, int& min_price_diff.tp_side, 
  int& max_price_diff.sl_side, int& max_price_diff.tp_side)
{
/*
  //sample
  
  if (sym == "EURUSD")
  {
    min_price_diff.sl_side = 0;
    min_price_diff.tp_side = 0;
    max_price_diff.sl_side = 20;
    max_price_diff.tp_side = 20;
    
    return;
  }
  
  if (sym == "GBPUSD") 
  {
    min_price_diff.sl_side = 15;
    min_price_diff.tp_side = 15;
    max_price_diff.sl_side = 50;
    max_price_diff.tp_side = 60;
  
    return;
  }
*/
 
  min_price_diff.sl_side = MinPriceDiff.StopLossSide;
  min_price_diff.tp_side = MinPriceDiff.TakeProfitSide;
  max_price_diff.sl_side = MaxPriceDiff.StopLossSide;
  max_price_diff.tp_side = MaxPriceDiff.TakeProfitSide;
}


double CustomLot(string sym, double master_lot)
{
  double lot = 1.0;
  
  return (lot);
}

